/**
  *  \file planetscentral/host/lock.h
  *  \brief Host: Locking
  */
#ifndef C2SERVER_PLANETSCENTRAL_HOST_LOCK_H
#define C2SERVER_PLANETSCENTRAL_HOST_LOCK_H

#include "cpluslib/types.h"

enum LockIntent {
    NoIntent,
    IntentDB,
    IntentCheckturn,
    IntentRunHost
};

bool lockGame(int32_t gameId, LockIntent intent);
void unlockGame(int32_t gameId);

class GameLock {
 public:
    GameLock(int32_t gameId);
    ~GameLock();
    bool lock(LockIntent intent);
    void lockOrDie(LockIntent intent);

 private:
    bool isLocked;
    int32_t gameId;
};

#endif
